#ifndef CRC__H
#define CRC__H

#include <stdio.h>
#include <string.h>

/*
unsigned long CRC32_STR(const char *buf)
{
	unsigned long nAccum = 0xFFFFFFFF;
	while (*buf)
	{
		nAccum = UPDC32(*buf, nAccum);
		buf++;
	}
	return ~nAccum;
}
unsigned long File_Size(const char *file)
{
	unsigned long file_size = 0;
	FILE* fp;
	fp = fopen( file, "rb");
	fseek( fp, 0, SEEK_END);
	file_size = ftell(fp);
	fclose(fp);
	return file_size;
}
*/

unsigned long CRC32_MEM(const unsigned char* InStr, unsigned long len)
{
	//Crc32Ĳѯ
	unsigned int Crc32Table[256] = {0};
	unsigned int Crc;
	for (unsigned int i = 0; i < 256; i++)
	{
		Crc = i;
		for (unsigned int j = 0; j < 8; j++)
		{
			if (Crc & 1)
				Crc = (Crc >> 1) ^ 0xEDB88320;
			else
				Crc >>= 1;
		}
		Crc32Table[i] = Crc;
	}

	//ʼCRC32Уֵ
	Crc = 0xFFFFFFFF;
	for (unsigned int i = 0; i < len; i++)
	{
		Crc = (Crc >> 8) ^ Crc32Table[(Crc & 0xFF) ^ InStr[i]];
	}

	Crc ^= 0xFFFFFFFF;
	return Crc;
}
unsigned long CRC32_FLE(const wchar_t *file)
{
	unsigned long nAccum = 0xFFFFFFFF;

	unsigned long file_size = 0;
	FILE* fp;
	fp = _wfopen( file, L"rb");
	fseek( fp, 0, SEEK_END);
	file_size = ftell(fp);
	fclose(fp);


	HANDLE hfile = CreateFile(file,
			GENERIC_READ,
			FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL, NULL);
	if (hfile == INVALID_HANDLE_VALUE)
	{
		return 0;
	}

	HANDLE hfilemap = CreateFileMapping(hfile, NULL, PAGE_READONLY, 0, 0, NULL);
	CloseHandle(hfile);

	unsigned char *buf = (unsigned char*) MapViewOfFile(hfilemap, FILE_MAP_READ, 0, 0, 0);
	CloseHandle(hfilemap);

	nAccum = CRC32_MEM(buf,file_size);
	
	UnmapViewOfFile(buf);
	return nAccum;
}

#endif /* CRC__H */
